[{
    Name: "Compact Generic Light",
    Author: "Generoso Martello, modified by Tara Saint",
    Version: "2015-03-09",

    IconImage: 'pages/control/widgets/homegenie/generic/images/light_off.png',
    StatusText: '',
    StatusIcon: '',
    
    RenderView: function (cuid, module) {
        var container = $(cuid);
        var widget = container.find('[data-ui-field=widget]');
        var controlpopup = widget.data('ControlPopUp');
        var toggle = widget.find('[data-ui-field=toggle]')
        
        //
        // Used to update the icon when we render or toggle
        //
        function UpdateIcon(level) {
          var widgeticon = HG.WebApp.Utility.GetModulePropertyByName(module, 'Widget.DisplayIcon');
          if (widgeticon != null && widgeticon.Value != '') {
              if (level > 0)
                  this.IconImage = widgeticon.Value.replace('_off', '_on');
              else
                  this.IconImage = widgeticon.Value;
          }
          else if (level > 0) {
              this.IconImage = 'pages/control/widgets/homegenie/generic/images/light_on.png';
          }
          else {
              this.IconImage = 'pages/control/widgets/homegenie/generic/images/light_off.png';
          }
          this.IconImage = '<img width="40" height="40" src="' + this.IconImage + '" style="vertical-align:middle" />';
          widget.find('[data-ui-field=statusicon]').html(this.IconImage);
        }

        //
        // Initialization -- If the controlpopup exists initialization has
        // already been done.
        //
        if (!controlpopup) {
          container.find('[data-ui-field=controlpopup]').trigger('create');
          controlpopup = container.find('[data-ui-field=controlpopup]').popup();
          widget.data('ControlPopUp', controlpopup);
          //
          // Controlpopup event handlers:
          //
          // controlpopup on and off button actions
          controlpopup.find('[data-ui-field=on]').on('click', function () {
              HG.Control.Modules.ServiceCall("Control.On", module.Domain, module.Address, null, function (data) { });
              UpdateIcon(true);
          });
          controlpopup.find('[data-ui-field=off]').on('click', function () {
              HG.Control.Modules.ServiceCall("Control.Off", module.Domain, module.Address, null, function (data) { });
              UpdateIcon(true);
          });
          //
          // Widget event handlers:
          //
          // switch action
          toggle.on('change', function () {
              var cmd = 'Control.' + toggle.val();
              HG.Control.Modules.ServiceCall(cmd, module.Domain, module.Address, null, function (data) { });
              UpdateIcon((toggle.val() == 'On') && true);
              //widget.find('[data-ui-field=statusicon]').html(this.IconImage);
          });
          // When name is clicked, module edit popup is shown
          widget.find('[data-ui-field=name]').on('click', function () {
              HG.WebApp.Control.EditModule(module);
          });
        }
        //
        // get module level and watts props to build StatusText
        //
        var watts = HG.WebApp.Utility.GetModulePropertyByName(module, "Meter.Watts");
        watts = watts || HG.WebApp.Utility.GetModulePropertyByName(module, "Sensor.Power"); // Some devices don't meter but instead measure
        watts = watts && Math.round(watts.Value.replace(',', '.'));
        var level = HG.WebApp.Utility.GetModulePropertyByName(module, "Status.Level");
        level = (level && Math.round(level.Value.replace(',', '.') * 100)) || (watts && 100); // if level is not available, but watts > 0, it's on.
        this.StatusText = (watts && (watts + 'W')) || (level && 'ON') || 'OFF';
        //
        // render widget
        //
        widget.find('[data-ui-field=name]').html(module.Name);
        widget.find('[data-ui-field=status]').html(this.StatusText);
        toggle.val((level && 'On') || 'Off');
        toggle.slider('refresh');
        UpdateIcon(level);
        //
        // render control popup - not that it is used ...
        //
        controlpopup.find('[data-ui-field=icon]').attr('src', this.IconImage);
        controlpopup.find('[data-ui-field=group]').html(container.attr('data-context-group'));
        controlpopup.find('[data-ui-field=name]').html(module.Name);
        controlpopup.find('[data-ui-field=status]').html(this.StatusText);
    }
}]